/******************************************************************************
;  *    @MCU                 : MC51F003A4
;  *    @Create Date         : 2022.09.27
;  *    @Author/Corporation  : sinomcu.com_FAE
;  *    @΢֧QQ     : 2048615934
;  *    @΢           : http://www.sinomcu.com/
;  *    @Copyright           : 2022 sinomcu.com Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *                             LCD 
       ʹ4λ8 1/4duty 1/2bias LCDʵ60ӼʱܣʱԶ0ʼ
    MCULCD£
    LCD_PIN  1     2     3      4    5     6     7     8     9     10    11    12
            COM1  COM2  COM3  COM4  SEG0  SEG1  SEG2  SEG3  SEG4  SEG5  SEG6  SEG7
             *     *     *     *     *     *     *     *     *     *     *     *
    MCU_PIN P25   P24   P23   P22   P17   P16   P15   P14   P13    P01   P00   P10                                     
******************************************************************************/

#include "User_Def.h"

#define COM0_VDD() { COM0 = 1;P2MOD1 = 0x54;P2MOD0 = 0xf5;LCDSW = 0xce; }//COM0 COM˿1/2VDDƽ
#define COM1_VDD() { COM1 = 1;P2MOD1 = 0x51;P2MOD0 = 0xf5;LCDSW = 0xcd; }//COM1 COM˿1/2VDDƽ
#define COM2_VDD() { COM2 = 1;P2MOD1 = 0x5f;P2MOD0 = 0x45;LCDSW = 0xcb; }//COM2 COM˿1/2VDDƽ
#define COM3_VDD() { COM3 = 1;P2MOD1 = 0x5f;P2MOD0 = 0x15;LCDSW = 0xc7; }//COM3 COM˿1/2VDDƽ

#define COM0_GND() { COM0 = 0;P2MOD1 = 0x54;P2MOD0 = 0xf5;LCDSW = 0xce; }//COM0 COM˿1/2VDDƽ
#define COM1_GND() { COM1 = 0;P2MOD1 = 0x51;P2MOD0 = 0xf5;LCDSW = 0xcd; }//COM1 COM˿1/2VDDƽ
#define COM2_GND() { COM2 = 0;P2MOD1 = 0x5f;P2MOD0 = 0x45;LCDSW = 0xcb; }//COM2 COM˿1/2VDDƽ
#define COM3_GND() { COM3 = 0;P2MOD1 = 0x5f;P2MOD0 = 0x15;LCDSW = 0xc7; }//COM3 COM˿1/2VDDƽ

//COM0_NUMʾѡCOM0ʱSEG(0-7)ֵ,COM04λABΣÿλABֵȡֵCOM0_NUMCOM˿
#define COM0_NUM ( (buf[num[0]]&0x03)<<6 | (buf[num[1]]&0x03)<<4 | (buf[num[2]]&0x03)<<2 | buf[num[3]]&0x03 )//
#define COM1_NUM ( (buf[num[0]]&0x0c)<<4 | (buf[num[1]]&0x0c)<<2 | buf[num[2]]&0x0c | (buf[num[3]]&0x0c)>>2 )
#define COM2_NUM ( (buf[num[0]]&0x30)<<2 | buf[num[1]]&0x30 | (buf[num[2]]&0x30)>>2 | (buf[num[3]]&0x30)>>4 )
#define COM3_NUM ( ((buf[num[0]]&0xc0) | (buf[num[1]]&0xc0)>>2 | (buf[num[2]]&0xc0)>>4 |(buf[num[3]]&0xc0)>>6) | x)

//ȫֱ
__O bit_flag flag1;
__O bit_flag SFR_interrupt_buff_H;
__O bit_flag SFR_interrupt_buff_L;

unsigned char num[4];                  //LCDԴ 0,1,2,3ֱӦLCDĻ0,1,2,3λ

//˽б
unsigned char position;                //COM˿ѡɨ8
unsigned char x;                       //м˸ֵ
unsigned int count_1s;                 //1sм1sһ

//0-9Ϊ0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f(PGFEDCBA) λѡΪ͵ƽѡܣѡΪߵƽ 
//LCDÿCOMŷֱʾ4λΣCOM14λABΣʽ0-9LCDʾ˳ΪPDECFGABõ±
code unsigned char buf[11]={0x7b,0x11,0x67,0x57,0x1d,0x5e,0x7e,0x13,0x7f,0x5f,0x00};//0,1,2,3,4,5,6,7,8,9

/************************************************
;  *    @Function Name       : main
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void main(void)
{
    GPIO_Init();
    Timer0_Init();
    Init_LCD_Buffer();                 //lcdԴʼ
    LCDCR0 = 0x80;                     //LCDģʾ
    LCDSW = 0xcf;                      //ڲѹ300kʹCOM0-COM1
    while (1)
    {
        if(FLAG_TIMER0_2ms == 1)       //2ms
        {
            FLAG_TIMER0_2ms =0;
            count_1s ++;
            
            if(count_1s < 250)         //ǰ0.5S,м
            {
                x = 0x80;
            }
            else if(count_1s < 500)    //м
            {
                x = 0x00;
            }
            else                       //1s
            {
                FLAG_TIMER0_1s = 1;    //1s־λ
                count_1s = 0;
            }
            /**********ɨ***********************/
            switch(position)
            {
                case 0:{ COM0_VDD();P1 = ~COM0_NUM; P0 = ( ~COM0_NUM&0x07)>>1; position = 1;break; } //COM0
                case 1:{ COM0_GND();P1 =  COM0_NUM; P0 = (  COM0_NUM&0x07)>>1; position = 2;break; }
                case 2:{ COM1_VDD();P1 = ~COM1_NUM; P0 = ( ~COM1_NUM&0x07)>>1; position = 3;break; } //COM1
                case 3:{ COM1_GND();P1 =  COM1_NUM; P0 = (  COM1_NUM&0x07)>>1; position = 4;break; }
                case 4:{ COM2_VDD();P1 = ~COM2_NUM; P0 = ( ~COM2_NUM&0x07)>>1; position = 5;break; } //COM2
                case 5:{ COM2_GND();P1 =  COM2_NUM; P0 = (  COM2_NUM&0x07)>>1; position = 6;break; }
                case 6:{ COM3_VDD();P1 = ~COM3_NUM; P0 = ( ~COM3_NUM&0x07)>>1; position = 7;break; } //COM3
                case 7:{ COM3_GND();P1 =  COM3_NUM; P0 = (  COM3_NUM&0x07)>>1; position = 0;break; }
                default :break;
            }
            clock_time();              //ʱʱ
            load();                    //װʾʱ
        }
    }
}

/**************************** end of file *********************************************/
